# ID Forwarding in Lab4
la   $9,target
la   $10,target2
la   $11, L6
la   $13, L7
addi $29, $0, 1
add  $2, $0, $0
bne  $2, $0, fail   # Test MEM-ID forwarding for RS
add  $3, $0, $0
bne  $0, $3, fail	# Test MEM-ID forwarding for RT
add  $2, $0, $29
beq  $2, $0, fail   # Test MEM-ID forwarding for RS
add  $3, $0, $29
beq  $0, $3, fail   # Test MEM-ID forwarding for RT
addi $3, $0, -1
bgtz $3, fail		# Test MEM-ID forwarding for RS
add  $3, $0, $29
blez $3, fail		# Test MEM-ID forwarding for RS
add  $4, $0, $29
addi $4, $0, -1
blez $4, L1			# Test MEM-ID for RS + Branch
addi $3, $0, -1
j	fail
nop
L1:	addi $3, $0, 1
	bgtz $3, L2		# Test MEM-ID for RS + Branch
	addi $3, $0, 0
	j	fail
	nop
L2:	beq $3, $0, L3 	# Test MEM-ID for RS + Branch
	addi $3, $0, 1
	j   fail
	nop
L3: addi $3, $0, 0
	beq $0, $3, L4 # Test MEM-ID for RT + Branch
	add $3, $0, $0,
	j	fail
	nop
L4: add $3, $0, $29
	bne $3, $0,	L5	# Test MEM-ID for RS + Branch
	add $3, $0, $0	
	j 	fail
	nop
L5:	add $3, $0, $29
	bne $0, $3, L6	# Test MEM-ID for RT + Branch
	addi $12, $11, 20
	j fail
	nop
L6:	jalr $12		# Test MEM-ID for RS on JR
	nop
	nop
	j	 negIDTests	
	nop
	jr   $31		# Test MEM-ID for RS on JR
	nop
negIDTests: xor	 $7, $7, $7
			add  $0, $29, $0
			lui  $2, 0x1000
			bne  $7, $0, fail  # Don't do MEM-ID if MEM_WriteReg == 0
			add  $0, $29, $0
			add  $4, $29, $0
			bne  $0, $7, fail  # Don't do MEM-ID if MEM_WriteReg == 0
			sw	 $29, 0($2)
			bne  $4, $29, fail  # Don't forward $29 if MEM_RegWrite == 0
			sw   $29, 0($2)
			bne  $29, $4, fail  # Don't forward $29 if MEM_RegWrite == 0
			nop

add  $4, $2, $0		# Test WB-EX forwarding for RS
addi $2, $0, 1		
addi $3, $2, 0		# Test MEM-EX forwarding for RS in face of Immediate
addi $4, $2, 0		# Test WB-EX forwarding for RS in face of Immediate
addi $2, $0, 2		
add $2, $2, $29		
add $3, $2, $29		# Check that MEM gets preference of WB ( $3 should get 4, not 3 )
addi $2, $0, 2		
addi $2, $2, 1		
addi $3, $2, 1		# Check that MEM gets preference of WB ( $3 should get 4, not 3 )

add  $5, $0, $0		
add  $6, $0, $5		# Test MEM-EX forwarding for RT
add  $7, $0, $5		# Test WB-EX forwarding for RT
addi $5, $0, 2		
add $5, $29, $5		
add $6, $29, $5		# Check that MEM gets preference over WB ( $6 should get 4, not 3 )
addi $5, $0, 2		
addi $5, $29, 1		
addi $5, $29, 1		# Check that Immediate gets preference over RT ($5 should get 2, not 4 )

add  $2, $29, $29
add  $3, $2, $29
add  $4, $2, $3     # test MEM-EX for RT, WB-EX for RS
add  $2, $29, $29
add  $3, $29, $2
add  $4, $3, $2     # test WB-EX for RT, MEM-EX for RS
add  $2, $29, $29		
add  $2, $2, $2		
add  $3, $2, $2		# test that both go WB-EX ... ($3 should get 8, not 4)

jal  target			
add  $5,$ra,$29		# test that $ra goes through ALU, is forwarded to RS
jalr $9				# jump to target again
add  $5,$ra,$29		# do same test for jalr
jalr $30,$10		# jump to target2, store return in $30
add  $5,$30,$29		# test forwarding of return address
j	 negTests
nop
target: sub $6,$5,$ra # test that $ra goes through ALU, is forwarded to RT
		jr $ra		  # gets $ra through RegFile
		nop
target2: sub $6,$5,$30 # test that $ra goes through ALU, is forwarded to RT
		jr $30		  # gets $ra through RegFile
		nop
negTests: add $0, $29, $29
	add $2, $0, $29  	# Don't go MEM-EX if WB_WriteReg == 0
	add $0, $29, $29
	nop
	add $2, $0, $29		# Don't go WB-EX if WB_WriteReg == 0  
	add $0, $29, $29		
	add $2, $29, $0		
	add $0, $29, $29
	lui $11,0x1000
	add $2, $0, $29
	sb	$3,0($11)	 	
	add $4,$3,$0		# Don't fwd MEM-EX for RS when MEM_RegWrite = 0
	add $4,$3,$0	    # Don't fwd WB-EX for RS when MEM_RegWrite = 0
	sh  $3,0($11)
	add $4,$0,$3		# Don't fwd MEM-EX for RT when MEM_RegWrite = 0
	add $4,$0,$3		# Don't fwd WB-EX for RT when MEM_RegWrite = 0
	add $12,$0,$11		
	sb  $2,0($12)		
	add $3,$12,$0		# Don't prefer MEM over WB for RS if MEM_RegWrite == 0
	add $2,$29,$29		
	sb  $2,0($11)		
	add $3,$2,$0		# Don't prefer MEM over WB for RT if MEM_RegWrite == 0
	sb  $11,4($11)
	sw  $11,8($11)
	add $12,$11,$11		# Don't forward if MEM_RegWrite == 0 && WB_RegWrite == 0
	lb  $13,0($11)		
	add $3,$13,$0		# Check for bubble here
	lh  $14,2($11)
	sub $4,$0,$14		# Check for bubble here
	addi $12,$11,4		
	sw  $12,8($12)
	lw  $12,8($12)		
	lw  $12,0($12)		# Check for bubble here
	sb  $0, 0($11)
	sh  $0, 2($11)
	sw  $0, 4($11)
	lb  $16, 0($11)
	bne $0,$16, fail	# Check for 2 bubbles
	lh	$17, 2($11)
	bne $17,$16, fail   # Check for 2 bubbles
	lw  $18, 4($11)
	bne $18,$17, fail   # Check for 2 bubbles
	nop
	lbu $16, 0($11)
	addi $11,$11,2
	bne $16, $0, fail
	lhu $17, 0($11)
	addi $11,$11,2
	bne $16, $17, fail
	lw  $18, 0($11)
	addi $11, $11, -4
	addi $28, $0, 5
	bne  $17, $18, fail
	addi $29,$29,-9
	addi $28, $0, 28
fail:	nop
	nop
	nop
	nop
	nop